//#########################################################################
// File: cardimage.c
//
// Liest Sektoren von der CF/MMC/SD und gibt sie
// ber RS232 binr aus.
//
// 115200 Baud, 8 Bit, 1 Stopbit, kein Parity, kein Handshake
// Prozessortakt 11.0592MHz
//
//#########################################################################
// Last change: 06.12.2006
//#########################################################################
// hk@holger-klabunde.de
// http://www.holger-klabunde.de/index.html
//#########################################################################
// Compiler: AVR-GCC 3.4.3
//#########################################################################
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

#include "mydefs.h"
#include "protos.h"
#include "../dos.h"
#include "../serial.h"
#include "../printf.h"

//###################################################################################
/* Hauptprogramm */
int main(void)
//###################################################################################
{
 DDRC=0xFF;  	// set io-pins on PortC
 PORTC=0; 	//LCD-Datenbus

 DDRD=0xF2;  	// set io-pins on PortD
 PORTD=0x02; 	//LCD-Steuersignale siehe lcd.h

 DDRA=0; 	//Alles Eingnge
 PORTA=0xFF; 	//Eingnge mit Pullups setzen

#ifdef COMPACTFLASH_CARD
 DDRB=0xFF; 	//Alles Ausgnge
 PORTB=0xFF; 	
#endif

#ifdef MMC_CARD_SPI
 MMC_IO_Init();
#endif

 SFIOR&=!(1<<PUD); 	//Pullups Enable
// SFIOR=0; 	//Pullups Enable

 ser_init();

 sei();              //enable interrupts

 RED_ON();
 GREEN_OFF();

 if(GetDriveInformation()!=F_OK) // get drive parameters
  {
   printf("Flash meldet sich nicht !");
   RED_OFF();
   GREEN_ON();
   while(1);
  }

   int i;
   unsigned long k;
   unsigned char *p,by;
   
   for(k=0; k<maxsect; k++) //Change number of sectors here
    {
     ReadSector(k,iob);

     p=iob;
 
     for(i=0; i<BYTE_PER_SEC; i++)
      {
       by=*p++;
       ser_putc(by);
      }//for i

    } //for k

 GREEN_ON();
 RED_OFF();
 cli(); // Disable interrupts
 
 for(;;) // loop forever
  {
  }
}

